<?php 
// Register scripts for front side
add_action( 'wp_enqueue_scripts', 'pmill_csit_enqueue_scripts' );
function pmill_csit_enqueue_scripts() {
	wp_register_script( 'pmill_dropbox_dropins', 'https://www.dropbox.com/static/api/2/dropins.js', array(), '0.0', 1 );
	wp_register_script( 'pmill_gdrive', 'https://apis.google.com/js/platform.js', array(), '', 1 );
	wp_register_script( 'pmill_csit_front', PMILL_CSIT_DIR.'modules/js/front.js', array('pmill_dropbox_dropins','jquery'), '', true );
	wp_register_style( 'pmill_csit_styles', PMILL_CSIT_DIR.'modules/css/front.css', '', PMILL_CSIT_VERSION, 'all' );
}

// Register and enqueue for admin
add_action( 'admin_enqueue_scripts', 'pmill_csit_admin_scripts' );
function pmill_csit_admin_scripts( $hook ) {
	global $post;
	if( $hook == 'post-new.php' || $hook == 'post.php' ) {
		// For TinyMCE
		wp_enqueue_style( 'pmill-csit-editor-font', PMILL_CSIT_DIR.'modules/css/fontello-cbc01577/css/mill-csit.css' );
	}
}

// Localize script for TinyMCE editor use
add_action( 'before_wp_tiny_mce', 'pmill_csit_localize_for_tinymce' );
function pmill_csit_localize_for_tinymce() {
	$params = array(
		'is_admin' => is_admin(), // Possible remove - not needed
		'plugin_dir' => PMILL_CSIT_DIR, // Possible remove - not needed
		'plugin_name' => PMILL_CSIT_PLUGIN_NAME
	);
	?>
	<script type='text/javascript'>
	/* <![CDATA[ */
	var pmill_csit_object = <?php echo json_encode( $params ); ?>;
	/* ]]> */
	</script>
	<?php
}
?>