<?php 
add_shortcode( 'pm_cloudsaveit', 'pmill_csit_shortcode_handler' );
function pmill_csit_shortcode_handler( $atts, $content = null ) {
	global $pmill_csit_opts;

	extract( shortcode_atts( array(
	  'file' => '',
	  'id' => '',
	  's3' => 'false'
	  ), $atts ) );

	// Process our variables
	$breakURL = parse_url($file);
	$getPath = pathinfo( $breakURL['path'] );
	$getFilename = $getPath['filename'];
	$getExt = $getPath['extension'];
	$blogname = get_bloginfo( 'name' );
	$filename = $getPath['filename'].'.'.$getPath['extension'];
	$id = ( empty( $id ) ) ? '1' : $id ;
	$dropbox_key = (empty($pmill_csit_opts['dropbox_key'])) ? '' : stripslashes($pmill_csit_opts['dropbox_key']);
	$local_label = (empty($pmill_csit_opts['local_label'])) ? 'Save To Local Drive' : stripslashes($pmill_csit_opts['local_label']);

	// Process variables for S3 protected files
	if( $s3 == 'true' ) {		
		$access_key = stripslashes( $pmill_csit_opts['s3access'] );
		$secret = stripslashes( $pmill_csit_opts['s3secret'] );
		$expiry = stripslashes( $pmill_csit_opts['s3expiry'] );
		$subdomain = str_replace('.s3.amazonaws.com', '', $breakURL['host']);
		// Get to the right bucket name
		if( $subdomain != 's3.amazonaws.com' ) { //Not sure why $subdomain is never empty
			$bucket = $subdomain;
			$filepath = $breakURL['path'];
			$filepath = ltrim($filepath, '/');
		} else {
			$subfolder = explode('/', $breakURL['path']);
			$bucket = $subfolder[1];
			$filepath = str_replace($bucket, '', $breakURL['path']);
			$filepath = ltrim($filepath, '/');
		}

		$expiry = ( empty( $expiry ) ) ? time()+sanitize_text_field( $config['expiry'] )*60 : time()+strip_tags( $expiry )*60;
		$string_to_sign = "GET\n\n\n$expiry\n/".str_replace(".s3.amazonaws.com","",$bucket)."/$filepath";
	    $signature = urlencode(base64_encode((hash_hmac("sha1", utf8_encode($string_to_sign), $secret, TRUE))));
		// Build file string
		    $file = 'http://' . $bucket . '.s3.amazonaws.com/' . $filepath . '?AWSAccessKeyId=' . $access_key . '&Expires=' . $expiry . '&Signature=' . $signature . '';
	}
	
	wp_enqueue_script( 'pmill_dropbox_dropins' );
	wp_enqueue_script( 'pmill_gdrive' );
	wp_enqueue_script( 'pmill_csit_front' );
	wp_enqueue_style( 'pmill_csit_styles' );
	$args = array(
		'appk' => $dropbox_key
		);
	wp_localize_script( 'pmill_csit_front', 'pmill_csit_obj', $args );

	$show_gdrive = ( empty( $pmill_csit_opts['rm_gdrive'] ) ) ? '<div id="pmill_csit_gdrive">
		<div class="g-savetodrive"
			data-src="'.$file.'"
			data-filename="'.$filename.'"
			data-sitename="'.$blogname.'">
		</div>
	</div>' : '' ;
	
	return <<<HTML
	<div class="pmill_csit_buttons">
	<div id="pmill_csit_local">
		<a href="{$file}">{$local_label}</a>
	</div>
	<div id="pmill_csit_dbox">
		<a id="pm-csit-db-{$id}" class="pmill-db-savetodrive"
			data-src="{$file}"
			data-filename="{$filename}"
			data-id="{$id}"><i id="pm-csit-{$id}" class="pmcsit-dropbox"></i>
			Save to Dropbox
		</a>
	</div>
	{$show_gdrive}	
	</div>
HTML;
}
?>